︠cdb2f955-d78b-47e0-8953-d25ea2166215︠
# Sage is a big calculator and it can compute taylor series
︡89ebeec7-c170-47ed-948d-b489af0fd185︡
︠46769a98-9408-41fa-ab04-d3bed87745fb︠
taylor(1/(1-q)^2,q,0,10)
︡3c5bd68f-3bfc-4764-b35f-fb5a5c93d0e7︡{"stdout":"11*q^10 + 10*q^9 + 9*q^8 + 8*q^7 + 7*q^6 + 6*q^5 + 5*q^4 + 4*q^3 + 3*q^2 + 2*q + 1\n"}︡
︠03d9e07f-4d06-4017-903f-441615f2be5a︠
var('z')
taylor(1/(1-z)^4,z,0,10)
︡493e35ca-224a-43b8-80e4-8f23fd3a6f48︡{"stdout":"z\n"}︡{"stdout":"286*z^10 + 220*z^9 + 165*z^8 + 120*z^7 + 84*z^6 + 56*z^5 + 35*z^4 + 20*z^3 + 10*z^2 + 4*z + 1\n"}︡
︠1aa46afb-eac7-48af-9ed4-cc1480bcbaba︠
︡0a59ac50-5a55-42f9-a4b9-b1442c6502d5︡{"stdout":"z\n"}︡
︠f1fffbbd-4c56-45f4-8a08-3f3699c738d2︠
# here is a simple if-then-elif-else
x=2
if x==1:
    print "one!"
elif x==2: # elif is short for "else if"
    print "two!"
else:
    print "not one or two!"
︡6c88983b-af4f-48be-a3a5-32245d24ee03︡{"stdout":"two!\n"}︡
︠8f269ad0-599a-4b72-b46f-9a70bbf5fbb1︠
# Note: hit return alone to move to the next line
# hit shift and return to evaluate an expression

# to write a function use the notation def functionname( variables ):
# this is an example of a function which converts positive integers into strings
def number_to_word( x ):
    names = ["zero","one","two","three","four","five","six","seven","eight","nine"]
    if x in range(10):
        return names[x] # lists start at position 0!!!!
    elif x<20:
        #do something else
        #should handle numbers 10 through 19
    elif x>=20 and x<100:
        #do somethign else
        # handle numbers 20 through 99 = "tenword" or "tenword"+" 1 throuth 9 word"
    else:
        return "not zero through one hundred!"
︡ae81141e-7a6e-4d91-8a39-401e6d5e78c5︡
︠6b60ada8-8dda-4132-874a-cb0cf2725a52︠
# Exercise write the function that returns a string for all numbers < 100
#hint add strings and they concatenate
"string 1"+" string 2"
︡d5f81c01-4f12-4d98-b303-ba0e30a1ac65︡{"stdout":"'string 1 string 2'\n"}︡
︠e3bc1fc1-f499-4ec8-9c88-3c6d8de4a639︠
""
number_to_word(0)
︡4149a3b7-d11c-4c56-aab8-c5f8b92a4355︡{"stdout":"'zero'\n"}︡
︠7e8d928f-82d7-42e1-ab89-9913665e9c3f︠
number_to_word(2)
︡df4657e1-e55f-4cf8-b886-39c1b2c4a5e1︡{"stdout":"'two'\n"}︡
︠1d503b68-8eeb-455e-8847-7deb911085a3︠
number_to_word(3)
︡72223304-57ba-4188-bf56-eb5d1aa824bc︡{"stdout":"'three'\n"}︡
︠94cc3777-7734-410a-93bb-b93a62f39fbd︠
for i in range(0,10):
    number_to_word(i)
︡4f1bfa6e-69fc-4b14-9236-802da2303c8f︡{"stdout":"'zero'\n'one'\n'two'\n'three'\n'four'\n'five'\n'not zero through five!'\n'not zero through five!'\n'not zero through five!'\n'not zero through five!'\n"}︡
︠b04a2022-8c55-4730-94dd-40715ac1db8c︠

︠ec7a32d2-ad1e-4bff-a70f-fcf2b2df90ad︠
range(0,10)
︡c3b313e7-853e-4bd5-b293-e1629e6eacb1︡{"stdout":"[0, 1, 2, 3, 4, 5, 6, 7, 8, 9]\n"}︡
︠ce98a8cf-ce12-47f9-8a6c-8204d932bd30︠
names = ["one","two","three","four","five"]
names[1]
︡ba464327-8aa6-466a-a17b-7be96a442344︡{"stdout":"'two'\n"}︡
︠bbb6a73b-8822-42c2-9803-180961ae4725︠
names[0]
︡085459f9-3045-4c7a-845a-e57ff1308431︡{"stdout":"'one'\n"}︡
︠d10f9f7f-3556-4ccd-9bb9-2fbd3b636f01︠
names[-1]
︡39d73838-6ebc-48fc-a3a2-b9ddd71677fd︡{"stdout":"'five'\n"}︡
︠3bb0d268-96d5-47f6-bdf5-04d9ff379ffa︠
# type G = Dih<tab> and then fill in (5)
G = DihedralGroup(5)
︡971202db-4dd2-48c0-8902-f6ae52fa59ff︡
︠00d5a80e-6608-4888-b6b8-e8e3cbef54e2︠
G
︡f3691745-d012-4006-ac61-f1a596439969︡{"stdout":"Dihedral group of order 10 as a permutation group"}︡{"stdout":"\n"}︡
︠0f810bbd-8a39-4e11-85b7-015d7f80fbda︠
# once sage knows G is a group, can type G.char<tab>
# and see a list of functions that beggin with "char"
G.character_table()
︡eb5d3014-adbd-4572-a8f0-afee26d2e76d︡{"stdout":"[                     1                      1                      1                      1]\n[                     1                     -1                      1                      1]\n[                     2                      0      zeta5^3 + zeta5^2 -zeta5^3 - zeta5^2 - 1]\n[                     2                      0 -zeta5^3 - zeta5^2 - 1      zeta5^3 + zeta5^2]"}︡{"stdout":"\n"}︡
︠4560bdd4-9db8-48b1-94d2-43a52fd8a6c2︠
G.list()
︡46e57485-d520-44eb-8d82-8e15a4365453︡{"stdout":"[(), (2,5)(3,4), (1,2)(3,5), (1,2,3,4,5), (1,3)(4,5), (1,3,5,2,4), (1,4)(2,3), (1,4,2,5,3), (1,5,4,3,2), (1,5)(2,4)]\n"}︡
︠c131e922-8365-44e2-afb9-4d108cf52866︠
# to list the conjugacy classes of G, start with G as a full set of elements
# and remove the conjugacy class as we calculate it
# step 1: start with set of G
# step 2: take first element in that set and compute conjugacy class
# step 3: subtract off that conjugacy class ... repeat until no elements left
G = SymmetricGroup(4)
Gset = Set(G.list())
while len(Gset)>0:
    g = Gset[0] #let g be the first element of Gset
    CC = Set([h*g*h^(-1) for h in G]) # this is the conjugacy class of g
    Gset = Gset.difference(CC)
    print CC
︡400adb2e-9609-4284-8230-5f51ccbb47cd︡{"stdout":"{(1,3,2,4), (1,4,3,2), (1,3,4,2), (1,2,3,4), (1,2,4,3), (1,4,2,3)}\n{(3,4), (1,2), (2,3), (1,4), (2,4), (1,3)}\n{(1,2,3), (1,3,4), (2,3,4), (2,4,3), (1,4,3), (1,2,4), (1,3,2), (1,4,2)}"}︡{"stdout":"\n{(1,4)(2,3), (1,3)(2,4), (1,2)(3,4)}\n{()}\n"}︡
︠c6e7e426-ad07-4ff5-9f47-18f5f54c761b︠
def my_conjugacy_classes( G ):
    Gset = Set(G.list())
    out = []
    while len(Gset)>0:
        g = Gset[0] #let g be the first element of Gset
        CC = Set([h*g*h^(-1) for h in G]) # this is the conjugacy class of g
        Gset = Gset.difference(CC)
        out.append(CC)
    return out
︡8c7c8996-2df7-425e-aa91-4b0df812ca23︡
︠67fe994e-83a2-4fa4-90ec-44d99dbe08bd︠
my_conjugacy_classes(DihedralGroup(4))
︡f0df4031-03d2-4297-a514-06b911fa6be0︡{"stdout":"[{(1,4,3,2), (1,2,3,4)}, {(1,3), (2,4)}, {(1,4)(2,3), (1,2)(3,4)}, {()}, {(1,3)(2,4)}]\n"}︡
︠9c64b18e-aee3-4270-8661-fadfcc14f2d9︠
my_conjugacy_classes(SymmetricGroup(3))
︡a39fa043-bf28-4a90-bb29-1f5dec129c21︡{"stdout":"[{(1,3), (1,2), (2,3)}, {()}, {(1,2,3), (1,3,2)}]\n"}︡
︠c82f4d58-d058-48ac-878a-f487917810a6︠
my_conjugacy_classes(DihedralGroup(7))
︡5431cc4a-f4bb-41bb-a34f-89dd0b9f616c︡{"stdout":"[{(1,5,2,6,3,7,4), (1,4,7,3,6,2,5)}, {(1,2)(3,7)(4,6), (2,7)(3,6)(4,5), (1,4)(2,3)(5,7), (1,6)(2,5)(3,4), (1,3)(4,7)(5,6), (1,7)(2,6)(3,5), (1,5)(2,4)(6,7)}, {(1,6,4,2,7,5,3), (1,3,5,7,2,4,6)}, {(1,7,6,5,4,3,2), (1,2,3,4,5,6,7)}, {()}]"}︡{"stdout":"\n"}︡
︠2939a8a8-a5ea-4c4b-98b3-32165ec36b9c︠
G.conjugacy_classes()
︡1c6a8af8-2a0b-4951-94cf-4a74764958df︡{"stdout":"[Conjugacy class of () in Symmetric group of order 4! as a permutation group, Conjugacy class of (1,2) in Symmetric group of order 4! as a permutation group, Conjugacy class of (1,2)(3,4) in Symmetric group of order 4! as a permutation group, Conjugacy class of (1,2,3) in Symmetric group of order 4! as a permutation group, Conjugacy class of (1,2,3,4) in Symmetric group of order 4! as a permutation group]\n"}︡
︠b5d11990-171c-4822-9250-4bbe99977943︠
SS = Set([1,2,3])
︡854d9220-1dd1-4a4f-ad91-27030ff25755︡
︠3c4e33dc-8833-4a60-a1e8-48d1aa22bccf︠
SS.difference([1])
︡4523f778-ee67-457d-ad90-dea8d77a511c︡{"stdout":"{2, 3}\n"}︡
︠cfddd40f-8ce1-4861-8d52-06dc794eff5f︠









